library("gmp")
library("numbers")

# Some primes I found earlier!
# Note these are crazy small for demo only
p <- as.bigz(971)
q <- as.bigz(823)

# Derive other params
n <- p*q
phi_n <- (p-1)*(q-1)

# Key length security
log2(n) # <20 bit! (2048-bit standard)

# A coprime I found earlier!
e <- as.bigz(61561)
gcd(e, phi_n) # = 1 ... Yes, it is co-prime

# Find the modular inverse for the secret key
d <- as.bigz( modinv(as.integer(e),as.integer(phi_n)) )
(e*d)%%phi_n # = 1 ... Yes, it is multiplicative inverse

# Check encrypting and decrypting a couple of values
m1 <- as.bigz(4)
c1 <- (m1^e)%%n
(c1^d)%%n # = 4 as reqd

m2 <- as.bigz(5)
c2 <- (m2^e)%%n
(c2^d)%%n # = 5 as reqd

# Back to slides before continuing ...

# Wonder what happens if ...
c3 <- (c1+c2)%%n
(c3^d)%%n

c4 <- (c1*c2)%%n
(c4^d)%%n

# Back to slides before continuing ...

# Dictionary attacks
for(i in 1:100) {
  testc <- (as.bigz(i)^e)%%n
  if(testc == c1) {
    cat("c1 is", i, "\n")
  }
  if(testc == c2) {
    cat("c2 is", i, "\n")
  }
  if(testc == c3) {
    cat("c3 is", i, "\n")
  }
  if(testc == c4) {
    cat("c4 is", i, "\n")
  }
}
