# Setup
m <- c(101, 103, 107)
M <- prod(m)

b <- b.inv <- rep(0,3)
for(i in 1:3) {
  b[i] <- M/m[i]
  b.inv[i] <- modinv(b[i], m[i])
}

# Store a vector of 3 values in a single
# scalar using Chinese Remainder Theorem
x <- c(2,4,7)
y <- c(3,5,1)
X <- sum(x*b*b.inv)%%M
Y <- sum(y*b*b.inv)%%M

# Check the value and recover
X
Y
X%%m
Y%%m

# Perform scalar arithmetic and
# recover vector arithmetic
Z <- (X+Y)%%M
Z
Z%%m

Z <- (X*Y)%%M
Z
Z%%m
